
local harbour = ...

-- Apply building asset processor
harbour:registerAssetProcessor("models/decorations/decoration.fbx", {
	DataType = "BUILDING_ASSET_PROCESSOR"
})

-- Create default minor decoration part registering function 
function registerDefaultMinorDecorationPart(_nameFbx, _nameAsset, _stoneCost)
    harbour:registerAssetId("models/decorations/decoration.fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", "HARBOUR_DECORATION_" .. _nameAsset .. "_PREFAB")

    harbour:register({
	DataType = "BUILDING_PART",
	Id = "HARBOUR_DECORATION_" .. _nameAsset .. "_PART",
	Name = "HARBOUR_DECORATION_" .. _nameAsset .. "_NAME",
	Description = "HARBOUR_DECORATION_" .. _nameAsset .. "_DESC",
	Category = "DECORATION",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "HARBOUR_DECORATION_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _stoneCost }
		}
	}
    })

    harbour:registerPrefabComponent("models/decorations/decoration.fbx/Prefab/decoration/Minor/" .. _nameFbx .. "Part", {
	DataType = "COMP_BUILDING_PART",
	BuildingPartType = "MINOR", -- Snaps the decoration only on minor attach nodes (here only on the facades)
  	HasBuildingZone = false,
	BuildingZone = { 0, 0 }
    })
end

registerDefaultMinorDecorationPart("SFenetre", "SFENETRE", 1)
registerDefaultMinorDecorationPart("LFenetre", "LFENETRE", 1)
registerDefaultMinorDecorationPart("PFenetre", "PFENETRE", 1)
registerDefaultMinorDecorationPart("ArrowSlit", "ARROWSLIT", 1)

-- Create default door decoration part registering function 
function registerDefaultDoorDecorationPart(_nameFbx, _nameAsset, _stoneCost)
    harbour:registerAssetId("models/decorations/decoration.fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", "HARBOUR_ENTRANCE_" .. _nameAsset .. "_PREFAB")

    harbour:register({
	DataType = "BUILDING_PART",
	Id = "HARBOUR_ENTRANCE_" .. _nameAsset .. "_PART",
	Name = "HARBOUR_ENTRANCE_" .. _nameAsset .. "_NAME",
	Description = "HARBOUR_ENTRANCE_" .. _nameAsset .. "_DESC",
	Category = "DOOR",
	Mover = { DataType = "BUILDING_PART_MOVER_INSTANCE" },
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "HARBOUR_ENTRANCE_" .. _nameAsset .. "_PREFAB",
                IsPreviewGroundVisible = false
	},
	Cost = {
		UpkeepCost = {
			{ Resource = "GOLD", Quantity = 0 }
		},
		RessourcesNeeded = { -- List of RESOURCE_QUANTITY_PAIR
			{ Resource = "STONE", Quantity = _stoneCost }
		}
	}
    })

-- Register grounding components
    harbour:registerPrefabComponent("models/decorations/decoration.fbx/Prefab/decoration/Entrance/" .. _nameFbx .. "Part", {
	DataType = "COMP_GROUNDED"
    })
end

registerDefaultDoorDecorationPart("DoorA", "DOOR_A", 1)
registerDefaultDoorDecorationPart("DoorB", "DOOR_B", 1)
